﻿using System;
using System.Windows.Forms;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Threading;
using System.Globalization;
using System.Diagnostics;

namespace WindowsFormsApplication1
{

    public partial class Form1 : Form
    {
        Bitmap image;
        const double eps = 0.00000000000000001;
        const double time_const = 0.00000003;
        const double const_k = 1.3806504;
        const int power_const_k = -23;
        const int power_m = -10;
        const int power_kg = -27;
        public int pix_r;
        public double m, t, r;
        int time = 0;
        public int n;
        Molecule[] mol;
        int situation = 1;
        List<Segment> segments = new List<Segment>();
        Point cur;
        float[,] Pos;
        float[,] cPos;
        double[] gist;
        int g_count = 20;
        float ELen;
        public Form1()
        {
            InitializeComponent();
            label1.Visible = false;
            pictureBox1.BackColor = Color.FromArgb(210, 210, 210);
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            hScrollBar1.Value = 110;
            hScrollBar2.Value = int.Parse(textBox2.Text) - 100;
            hScrollBar3.Value = 15;
            //label1.Visible = false;
            m = val2kg(hScrollBar3.Value);
            t = 300;
            r = pix2m(hScrollBar1.Value);
            // pix_r = 12;
        }



        public double pix2m(float x)
        {
            return (10e-10) * x;
        }

        public double pix2m1(float x)
        {
            return (10) * x;
        }

        public float m2pix(double x)
        {
            return (float)(x / (10e-10));
        }

        public double val2kg(int val)
        {
            return 1.660538 * val;
        }

        public int kg2val(double kg)
        {
            return (int)(kg / 1.660538);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.MinimumSize = Screen.PrimaryScreen.Bounds.Size;
        }

        double e_v;
        private void button1_Click(object sender, EventArgs e)
        {
            n = (int)numericUpDown1.Value;

            time = 0;
            mol = new Molecule[n];
            for (int i = 0; i < n; ++i)
                mol[i] = new Molecule(m, t, r, pix_r, pictureBox1.Width, pictureBox1.Height);

            for (int i = 0; i < n; ++i)
                e_v += Math.Sqrt(mol[i].vx * mol[i].vx + mol[i].vy * mol[i].vy);

            e_v /= 1.0 * n;
            double x = mol[0].x;
            double y = mol[0].y;
            float pix_x = m2pix(x);
            float pix_y = m2pix(y);

            cur = new Point(pix_x, pix_y);
            timer1.Interval = 2;
            timer1.Enabled = true;
            button1.Enabled = false;
        }

        class Point
        {
            public float x, y;
            public Point(float X, float Y)
            {
                x = X;
                y = Y;
            }

        }

        class Segment
        {
            public Point p1, p2;
            public Segment(Point a, Point b)
            {
                p1 = a;
                p2 = b;
            }

            public double Length()
            {
                double x = p1.x - p2.x;
                double y = p1.y - p2.y;
                return Math.Sqrt(x * x + y * y);
            }


        }
        class Molecule
        {
            static Random rand = new Random();
            static Random rand1 = new Random();
            static Random rand2 = new Random();
            public double m, t, vx, vy, r, x, y;


            public int power_D;
            public int pix_x, pix_y, pix_r;
            public Molecule(double M, double T, double R, int pix_R, int width, int height)
            {
                r = R;
                m = M;
                t = T;
                pix_r = pix_R;
                double avg_v = 0;
                power_D = power_const_k - power_kg;
                double D = const_k * t / m;

                D = Math.Sqrt(D);
                if (power_D % 2 == 0) power_D /= 2;
                else
                {
                    power_D--;
                    D *= Math.Sqrt(10);
                    power_D /= 2;
                }
                generate(avg_v, D, power_D);
                //       vx = vy = 1;
                pix_x = rand.Next(pix_r + 1, width - pix_r - 1);
                pix_y = rand.Next(pix_r + 1, height - pix_r - 1);

                x = pix2m(pix_x);
                y = pix2m(pix_y);
            }

            public double pix2m(int x)
            {
                return (10e-10) * x;
            }

            public double pix2m1(int x)
            {
                return (10) * x;
            }

            public float m2pix(double x)
            {
                return (float)(x / (10e-10));
            }

            public double val2kg(int val)
            {
                return 1.660538 * val;
            }

            public int kg2val(double kg)
            {
                return (int)(kg / 1.660538);
            }


            private void generate(double E, double D, double power_D)
            {
                double u1, u2, v1, v2, s;
                do
                {
                    u1 = rand1.NextDouble();
                    u2 = rand2.NextDouble();
                    v1 = 2 * u1 - 1;
                    v2 = 2 * u2 - 1;
                    s = v1 * v1 + v2 * v2;
                } while (s >= 1);

                if (s == 0)
                {
                    generate(E, D, power_D);
                    return;
                }
                vx = (v1 * Math.Sqrt(-2 * Math.Log(s) / s));
                vy = (v2 * Math.Sqrt(-2 * Math.Log(s) / s));
                vx = (E + D * vx);
                vy = (E + D * vy);

            }
        }


        double dist(double x1, double y1, double x2, double y2)
        {
            return Math.Sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
        }

        int intersected = 0;

        private void Draw()
        {
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics graph = Graphics.FromImage(image);
            graph.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
            
            double min_time = timer1.Interval;
            double i_min = -1;

            double x = mol[0].x + mol[0].vx * 0.02 * time_const;
            double y = mol[0].y + mol[0].vy * 0.02 * time_const;
            float pix_x1 = m2pix(x) + pix_r / 2;
            float pix_y1 = m2pix(y) + pix_r / 2;


            Point t = new Point(pix_x1, pix_y1);

            for (int i = 0; i < n; ++i)
            {
                //  graph.DrawEllipse(Pens.OrangeRed, mol[i].x + mol[i].vx * time, mol[i].y + mol[i].vy * time, r, r);
                try
                {
                    mol[i].x += mol[i].vx * 0.02 * time_const;
                    mol[i].y += mol[i].vy * 0.02 * time_const;

                    double x_1 = mol[i].x;
                    double y_1 = mol[i].y;

                    float pix_x = m2pix(x_1);
                    float pix_y = m2pix(y_1);

                    if (pix_x < 0)
                    {
                        mol[i].x = 0;
                        mol[i].vx = -mol[i].vx;
                        mol[i].vy = mol[i].vy;
                        if (i == 0)
                        {
                            Segment seg = new Segment(cur, t);
                            if (seg.Length() > 0)
                                segments.Add(seg);
                            cur = t;
                        }
                    }

                    if (pix_x + pix_r > pictureBox1.Width)
                    {
                        mol[i].x = pix2m(pictureBox1.Width - pix_r);
                        mol[i].vx = -mol[i].vx;
                        mol[i].vy = mol[i].vy;
                        if (i == 0)
                        {
                            Segment seg = new Segment(cur, t);
                            if (seg.Length() > 0)
                                segments.Add(seg);
                            cur = t;
                        }

                    }

                    if (pix_y < 0)
                    {

                        mol[i].y = 0;
                        mol[i].vx = mol[i].vx;
                        mol[i].vy = -mol[i].vy;
                        if (i == 0)
                        {
                            Segment seg = new Segment(cur, t);
                            if (seg.Length() > 0)
                                segments.Add(seg);
                            cur = t;
                        }

                    }

                    if (pix_y + pix_r > pictureBox1.Height)
                    {

                        mol[i].y = pix2m(pictureBox1.Height - pix_r);
                        mol[i].vx = mol[i].vx;
                        mol[i].vy = -mol[i].vy;
                        if (i == 0)
                        {
                            Segment seg = new Segment(cur, t);
                            if (seg.Length() > 0)
                                segments.Add(seg);
                            cur = t;
                        }

                    }

                    if (i == 0)
                    {
                        graph.FillEllipse(Brushes.Black, pix_x, pix_y, pix_r, pix_r);
                        continue;
                    }

                    if (dist(pix_x, pix_y, m2pix(mol[0].x), m2pix(mol[0].y)) <= pix_r && intersected != i)
                    {

                        intersected = i;
                        double x1 = mol[i].x;
                        double y1 = mol[i].y;
                        double x2 = mol[0].x;
                        double y2 = mol[0].y;


                        double vx1 = mol[i].vx;
                        double vy1 = mol[i].vy;
                        double vx2 = mol[0].vx;
                        double vy2 = mol[0].vy;

                        double rx = x1 - x2;
                        double ry = y1 - y2;

                        double len = Math.Sqrt(rx * rx + ry * ry);

                        double vect_mul = ry;
                        double sin_alpha = vect_mul / len;

                        double sc_mul = rx;
                        double cos_alpha = sc_mul / len;

                        double vn1 = vx1 * cos_alpha + vy1 * sin_alpha;
                        double vt1 = vy1 * cos_alpha - vx1 * sin_alpha;


                        double vn2 = vx2 * cos_alpha + vy2 * sin_alpha;
                        double vt2 = vy2 * cos_alpha - vx2 * sin_alpha;


                        double tmp = vn1;
                        vn1 = vn2;
                        vn2 = tmp;

                        vx1 = vn1 * cos_alpha - vt1 * sin_alpha;
                        vy1 = vn1 * sin_alpha + vt1 * cos_alpha;


                        vx2 = vn2 * cos_alpha - vt2 * sin_alpha;
                        vy2 = vn2 * sin_alpha + vt2 * cos_alpha;

                        mol[i].vx = vx1;
                        mol[i].vy = vy1;
                        mol[0].vx = vx2;
                        mol[0].vy = vy2;


                        Segment seg = new Segment(cur, t);
                        if (seg.Length() > 0)
                            segments.Add(seg);
                        cur = t;

                    }

                    graph.FillEllipse(Brushes.Blue, pix_x, pix_y, pix_r, pix_r);
                }
                catch
                {
                }
            }

            for (int i = 0; i < segments.Count; ++i)
            {
                Segment seg = (Segment)segments[i];
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawLine(pen, seg.p1.x, seg.p1.y, seg.p2.x, seg.p2.y);
            }

            Pen pen1 = new Pen(Color.Black, 2);
            graph.DrawLine(pen1, cur.x, cur.y, t.x, t.y);
            pictureBox1.Image = image;
        }
        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
        }

        private void hScrollBar3_Scroll(object sender, ScrollEventArgs e)
        {
            int tmp = e.NewValue;
            m = val2kg(tmp);
            textBox3.Text = tmp.ToString();
            label1.Text = hScrollBar3.Value.ToString();
        }

        private void hScrollBar2_Scroll(object sender, ScrollEventArgs e)
        {
            t = e.NewValue + 100;
            textBox2.Text = t.ToString();
        }

        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            pix_r = e.NewValue / 10;
            r = pix2m(pix_r);
            textBox1.Text = hScrollBar1.Value.ToString();

            label1.Text = hScrollBar1.Value.ToString();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            ++time;
            if (situation == 1)
            {
                Draw();
            }
            else if (situation == 2)
            {
                Draw2();
            }
            else if (situation == 3)
            {
                Draw3();
            }
        }

        private void stop_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);

            pictureBox1.Image = image;
            Graphics graph = Graphics.FromImage(image);
            double x = mol[0].x + mol[0].vx * 0.02 * time_const;
            double y = mol[0].y + mol[0].vy * 0.02 * time_const;
            float pix_x1 = m2pix(x) + pix_r / 2.0f;
            float pix_y1 = m2pix(y) + pix_r / 2.0f;


            Point t = new Point(pix_x1, pix_y1);
            Segment seg = new Segment(cur, t);
            if (seg.Length() > 0)
                segments.Add(seg);

            for (int i = 0; i < segments.Count; ++i)
            {
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawLine(pen, segments[i].p1.x, segments[i].p1.y, segments[i].p2.x, segments[i].p2.y);
            }
            pictureBox1.Image = image;
            pictureBox1.Refresh();
            stop.Enabled = false;

            button2.Enabled = true;

          //  MessageBox.Show("Нажмите продолжить, чтобы отсортировать отрезки по длине.");
        }

        List<Segment> Ls = new List<Segment>();

        void Draw2()
        {
            int i, j = 0;
            float vx, vy;
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            pictureBox1.Image = image;
            Graphics graph = Graphics.FromImage(image);
            //Ls.Clear();
            for (i = 0; i < segments.Count; ++i)
            {
                //Segment s = new Segment (segments[i].p1, segments[i].p2);
                vx = Pos[i, 0] - cPos[i, 0];
                vy = Pos[i, 1] - cPos[i, 1];
                if ((vx == 0) && (vy == 0))
                {
                    ++j;
                }
                else
                {
                    float ln = (float)Math.Sqrt((double)(vx * vx + vy * vy));
                    vx /= ln;
                    vy /= ln;
                }
                if (Math.Abs(((float)10 * vx)) < Math.Abs((Pos[i, 0] - cPos[i, 0])))
                {
                    cPos[i, 0] += (float)10 * vx;
                }
                else
                {
                    cPos[i, 0] = Pos[i, 0];
                }
                if (Math.Abs(((float)10 * vy)) < Math.Abs((Pos[i, 1] - cPos[i, 1])))
                {
                    cPos[i, 1] += (float)10 * vy;
                }
                else
                {
                    cPos[i, 1] = Pos[i, 1];
                }
                vx = Pos[i, 2] - cPos[i, 2];
                vy = Pos[i, 3] - cPos[i, 3];
                if ((vx == 0) && (vy == 0))
                {
                    ++j;
                }
                else
                {
                    float ln = (float)Math.Sqrt((double)(vx * vx + vy * vy));
                    vx /= ln;
                    vy /= ln;
                }
                if (Math.Abs(((float)10 * vx)) < Math.Abs((Pos[i, 2] - cPos[i, 2])))
                {
                    cPos[i, 2] += (float)10 * vx;
                }
                else
                {
                    cPos[i, 2] = Pos[i, 2];
                }
                if (Math.Abs(((float)10 * vy)) < Math.Abs((Pos[i, 3] - cPos[i, 3])))
                {
                    cPos[i, 3] += (float)10 * vy;
                }
                else
                {
                    cPos[i, 3] = Pos[i, 3];
                }
                //Ls.Add(s);
            }
            //Ls.Reverse();
            //segments.Clear();
            for (i = 0; i < segments.Count; ++i)
            {
                //Segment s = new Segment(Ls[i].p1, Ls[i].p2);
                //segments.Add(s);
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawLine(pen, cPos[i, 0], cPos[i, 1], cPos[i, 2], cPos[i, 3]);
            }
            pictureBox1.Image = image;
            if (j == 2 * segments.Count)
            {
              //  Thread.Sleep(4000);
                Stop2();         
            }
        }

        float Len, Lenone, Hg, gLen;
        bool[] was;

        void Draw_prob()
        {
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics graph = Graphics.FromImage(image);
            float cur_x = 10;
            int max_gist = 0;
            int i;
            for (i = 0; i < g_count + 1; ++i)
            {
                if (gist[i] > max_gist)
                {
                    max_gist = (int)gist[i];
                }
            }
            //int tek = 0;
            label1.Text = segments.Count.ToString();
            float d_gist = (float)(pictureBox1.Height - 70) / max_gist;
            /*for (int q = 0; q <= 10; ++q)
            {
                graph.DrawString(tek.ToString(), new Font("Arial", 8), new SolidBrush(Color.White), cur_x, pictureBox1.Height - cur - 12);
                cur += (pictureBox1.Height  / 10);
                tek += d_gist;
 
            }*/


            float maxx = 0;
            Hg = (pictureBox1.Height - 70) * 1.0f / max_gist;
            for (i = 0; i < g_count + 1; ++i)
            {
                int x = 50 + (int)(gLen * i);
                if (x > maxx) maxx = x;
                if (gist[i] > max_gist) max_gist = (int)gist[i];
                int y = pictureBox1.Height - (int)(Hg * gist[i]);

                Rectangle rect = new Rectangle(x, y - 20, (int)gLen, (int)(Hg * gist[i]));

                graph.FillRectangle(Brushes.Blue, rect);

                graph.DrawRectangle(Pens.White, rect);
            }
            pictureBox1.Image = image;

            graph.DrawLine(Pens.Blue, 50, pictureBox1.Height - 20, pictureBox1.Width - 50, pictureBox1.Height - 20);
            float cur = 0;
            cur_x = 50;
            cur = 0;
            float cur2 = 0;

            int step;
            if (Len < 10) step = 2;
            else if (Len < 100) step = 20;
            else if (Len < 200) step = 50;
            else if (Len < 400) step = 100;
            else if (Len < 800) step = 200;
            else if (Len < 1000) step = 250;
            else step = 500;

            for (i = 0; i <= 4; ++i, cur += step, cur_x += 2 * gLen * 10 * step / Len)
            {
                float tmp = cur * 2;
                tmp = (float)pix2m1(tmp);
                int tmp1 = (int)tmp;
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawLine(pen, cur_x + 1, pictureBox1.Height - 15, cur_x + 1, pictureBox1.Height - 25);
                graph.DrawString(tmp1.ToString(), new Font("Arial", 17.5f), new SolidBrush(Color.Black), cur_x - 18, pictureBox1.Height - 21);
            }

            label11.Visible = false;
            label12.Visible = true;

            graph.DrawLine(Pens.Blue, 50, pictureBox1.Height - 20, 50, 0);
            cur = 0;
            cur2 = 0;

            float step1;
            if (max_gist / segments.Count < 0.5) step1 = 0.1f;
            else step1 = 0.2f;

            float prev = pictureBox1.Height - 20;
            for (i = 0; i <= 4; ++i, cur += d_gist*step1*segments.Count, cur2 += step1)
            {
                float tmp = (cur2);
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawString(tmp.ToString(), new Font("Arial", 17.5f), new SolidBrush(Color.Black), 18, pictureBox1.Height - 20 - cur);
                graph.DrawLine(pen , 45, pictureBox1.Height - 20 - cur, 55, pictureBox1.Height - 20 - cur);
                float small_y = (pictureBox1.Height - 20 - cur - prev) / 5.0f;
                float cur_small = prev;
                for (int r = 0; r < 5; ++r)
                {
                    cur_small += small_y;
                    Pen pen1 = new Pen(Color.Black, 2);
                    graph.DrawLine(pen1, 48, cur_small, 52, cur_small);
                }
                prev = pictureBox1.Height - 20 - cur;
            }


            pictureBox1.Image = image;
            pictureBox1.Refresh();
            button2.Enabled = true;
          //  MessageBox.Show("Нажмите продолжить, чтобы угадать длину свободного пробега.");
        }
        void Draw3()
        {
            int i, j = 0, t;
            float vx, vy;
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            pictureBox1.Image = image;
            Graphics graph = Graphics.FromImage(image);
            //Ls.Clear();
            for (i = 0; i < segments.Count; ++i)
            {
                //Segment s = new Segment (segments[i].p1, segments[i].p2);
                t = 0;
                vx = Pos[i, 0] - cPos[i, 0];
                vy = Pos[i, 1] - cPos[i, 1];
                if ((vx == 0) && (vy == 0))
                {
                    ++t;
                }
                else
                {
                    float ln = (float)Math.Sqrt((double)(vx * vx + vy * vy));
                    vx /= ln;
                    vy /= ln;
                }
                if (Math.Abs(((float)5 * vx)) < Math.Abs((Pos[i, 0] - cPos[i, 0])))
                {
                    cPos[i, 0] += (float)5 * vx;
                }
                else
                {
                    cPos[i, 0] = Pos[i, 0];
                }
                if (Math.Abs(((float)5 * vy)) < Math.Abs((Pos[i, 1] - cPos[i, 1])))
                {
                    cPos[i, 1] += (float)5 * vy;
                }
                else
                {
                    cPos[i, 1] = Pos[i, 1];
                }
                vx = Pos[i, 2] - cPos[i, 2];
                vy = Pos[i, 3] - cPos[i, 3];
                if ((vx == 0) && (vy == 0))
                {
                    ++t;
                }
                else
                {
                    float ln = (float)Math.Sqrt((double)(vx * vx + vy * vy));
                    vx /= ln;
                    vy /= ln;
                }
                if (Math.Abs(((float)5 * vx)) < Math.Abs((Pos[i, 2] - cPos[i, 2])))
                {
                    cPos[i, 2] += (float)5 * vx;
                }
                else
                {
                    cPos[i, 2] = Pos[i, 2];
                }
                if (Math.Abs(((float)5 * vy)) < Math.Abs((Pos[i, 3] - cPos[i, 3])))
                {
                    cPos[i, 3] += (float)5 * vy;
                }
                else
                {
                    cPos[i, 3] = Pos[i, 3];
                }
                j += t;
                if ((t == 2) && (!was[i]))
                {
                    was[i] = true;
                    float lng = (float)segments[i].Length() / 2.0f;
                    int bs = (int)(lng / Lenone);
                    ++gist[bs];
                }
                //Ls.Add(s);
            }
            //Ls.Reverse();
            //segments.Clear();
            for (i = 0; i < segments.Count; ++i)
            {
                //Segment s = new Segment(Ls[i].p1, Ls[i].p2);
                //segments.Add(s);
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawLine(pen, cPos[i, 0], cPos[i, 1], cPos[i, 2], cPos[i, 3]);
            }
            int maxx = 0;
            int max_gist = 0;
            float prob = 0;
            float gist_max = 0;

            float norm = 0;
            for (i = 0; i < g_count + 1; ++i)
            {
                int x = 50 + (int)(gLen * i);
                if (x > maxx) maxx = x;
                if (gist[i] > max_gist) max_gist = (int)gist[i];
                int y = pictureBox1.Height - (int)(Hg * gist[i]);

                Rectangle rect = new Rectangle(x, y - 20, (int)gLen, (int)(Hg * gist[i]));
                graph.FillRectangle(Brushes.Blue, rect);
                graph.DrawRectangle(Pens.White, rect);
            }
            pictureBox1.Image = image;
            if (j == 2 * segments.Count)
            {
                image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
                graph = Graphics.FromImage(image);
                float cur_x = 10;
                max_gist = 0;
                for (i = 0; i < g_count + 1; ++i)
                {
                    if (gist[i] > max_gist)
                    {
                        max_gist = (int)gist[i];
                    }
                }
                graph.DrawLine(Pens.Blue, 50, pictureBox1.Height - 20, 50, 50);
                float cur = 0;
                float cur2 = 0;
                int tek = 0;
                label1.Text = segments.Count.ToString();
                float d_gist = (float)(pictureBox1.Height - 70) / max_gist;

                /*for (int q = 0; q <= 10; ++q)
                {
                    graph.DrawString(tek.ToString(), new Font("Arial", 8), new SolidBrush(Color.White), cur_x, pictureBox1.Height - cur - 12);
                    cur += (pictureBox1.Height  / 10);
                    tek += d_gist;
 
                }*/


//                for (i = 0; i <= 10; ++i, cur += d_gist, cur2 += max_gist / 10.0f)
  //              {
    //                float tmp = (float)Math.Round((double)cur2);
      //              graph.DrawString(tmp.ToString(), new Font("Arial", 8), new SolidBrush(Color.White), 30, pictureBox1.Height - 20 - cur);
        //        }

                Hg = (pictureBox1.Height - 70) * 1.0f / max_gist;
                for (i = 0; i < g_count + 1; ++i)
                {
                    int x = 50 + (int)(gLen * i);
                    if (x > maxx) maxx = x;
                    if (gist[i] > max_gist) max_gist = (int)gist[i];
                    int y = pictureBox1.Height - (int)(Hg * gist[i]);

                    Rectangle rect = new Rectangle(x, y - 20, (int)gLen, (int)(Hg * gist[i]));
                    graph.FillRectangle(Brushes.Blue, rect);
                    graph.DrawRectangle(Pens.White, rect);
                }

                label10.Visible = true;
                graph.DrawLine(Pens.Blue, 50, pictureBox1.Height - 20, pictureBox1.Width - 50, pictureBox1.Height - 20);
                cur = 0;
                cur_x = 50;
                cur = 0;
                cur2 = 0;

                int step;
                if (Len < 10) step = 2;
                else if (Len < 100) step = 20;
                else if (Len < 200) step = 50;
                else if (Len < 400) step = 100;
                else if (Len < 800) step = 200;
                else if (Len < 1000) step = 250;
                else step = 500;

                for (i = 0; i <= 4; ++i, cur += step, cur_x += 2 * gLen * 10  * step / Len)
                {
                    float tmp = cur * 2;
                    tmp = (float)pix2m1(tmp);
                    int tmp1 = (int)tmp;
                    Pen pen = new Pen(Color.Black, 2);
                    graph.DrawLine(pen, cur_x + 1, pictureBox1.Height - 15, cur_x + 1, pictureBox1.Height - 25);
                    graph.DrawString(tmp1.ToString(), new Font("Arial", 17.5f), new SolidBrush(Color.Black), cur_x, pictureBox1.Height - 21);
                }


                graph.DrawLine(Pens.Blue, 50, pictureBox1.Height - 20, 50, 0);
                label11.Visible = true;
                cur = 0;
                cur2 = 0;


                if (max_gist < 10) step = 2;
                else if (max_gist < 100) step = 20;
                else if (max_gist < 200) step = 50;
                else if (max_gist < 400) step = 100;
                else if (max_gist < 800) step = 200;
                else if (max_gist < 1000) step = 250;
                else step = 500;
                
                float prev = pictureBox1.Height - 20;
                for (i = 0; i <= 4; ++i, cur += d_gist*step, cur2 += step)
                {
                    float tmp = (cur2);
                    Pen pen = new Pen(Color.Black, 2);
                    graph.DrawString(tmp.ToString(), new Font("Arial", 17.5f), new SolidBrush(Color.Black), 18, pictureBox1.Height - 20 - cur);
                    graph.DrawLine(pen, 45, pictureBox1.Height - 20 - cur, 55, pictureBox1.Height - 20 - cur);
                    float small_y = (pictureBox1.Height - 20 - cur - prev) / 5.0f;
                    float cur_small = prev;
                    for (int r = 0; r < 5; ++r)
                    {
                        cur_small += small_y;
                        Pen pen1 = new Pen(Color.Black, 2);
                        graph.DrawLine(pen1, 48, cur_small, 52, cur_small);
                    }
                    prev = pictureBox1.Height - 20 - cur;
                }

                label1.Text = max_gist.ToString();
                pictureBox1.Image = image;
           //     return;
                pictureBox1.Refresh();
//                Thread.Sleep(3000);
                //---------------------------------------------------------------------------
                /*for (float x = 50; x < maxx; x += 4*gLen)
                {
                    graph.DrawString(pix2m1((int)x).ToString(), new Font("Arial", 12), new SolidBrush(Color.White), x, pictureBox1.Height - 14);
                }
                pictureBox1.Image = image;
                pictureBox1.Refresh();
                Thread.Sleep(3000);

                return;
                image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
                graph = Graphics.FromImage(image);
                prob = 0;
                gist_max = 0;
                for (int q = 0; q < g_count + 1; ++q)
                    if (Hg * gist[q] > gist_max) gist_max = (float)(Hg * gist[q]);

                norm = (float)((pictureBox1.Height - 10) * 1.0 / gist_max);
                int sum = segments.Count;
                for (i = 0; i < g_count + 1; ++i)
                {
                    int x = 50 + (int)(gLen * i);
                    if (x > maxx) maxx = x;
                    int y = pictureBox1.Height - (int)(Hg * gist[i] *norm);
                    Rectangle rect = new Rectangle(x, y, (int)gLen, (int)(Hg * gist[i]*norm));
                    graph.DrawRectangle(Pens.Aqua, rect);
                }

                int k = 0;
                for (float x = 50; x < maxx; x += 4 * gLen)
                {
                    graph.DrawString(prob.ToString("0.00"), new Font("Arial", 12), new SolidBrush(Color.White), x, pictureBox1.Height - 14);
                    if (prob == 1.0) break;
                    prob += (float)((gist[k] + gist[k + 1] + gist[k + 2] + gist[k + 3]) * 1.0 / sum);
                    k += 4;
                }

                cur = 0;
                tek = 0;
                d_gist = max_gist / 10;
                for (int q = 0; q < 10; ++q)
                {
                    graph.DrawString(tek.ToString(), new Font("Arial", 12), new SolidBrush(Color.White), cur_x, pictureBox1.Height - cur - 12);
                    cur += (pictureBox1.Height / 10);
                    //tek += d_gist;

                }
                pictureBox1.Image = image;*/



                label1.Text = segments.Count.ToString();
                timer1.Enabled = false;
                button2.Enabled = true;
             //   MessageBox.Show("Нажмите продолжить, чтобы посмотреть гистограмму с вероятностями.");
            //    Stop3();
            }
        }

        void Stop2()
        {
            int i, j;
            timer1.Enabled = false;
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);

            //Thread.Sleep(3000);
            Len = 0.0f;
            label9.Visible = true;
            for (i = 0; i < segments.Count; ++i)
            {
                if (segments[i].Length() > Len)
                {
                    Len = (float)segments[i].Length();
                }
            }
            Len /= 2.0f;
            pictureBox1.Refresh();
            float norm = (pictureBox1.Height - 70) / Len;
            Graphics graph = Graphics.FromImage(image);
            float mn = 10000, mx = 0;
            for (i = 0; i < segments.Count; ++i)
            {
                if (Pos[i, 0] < mn)
                {
                    mn = Pos[i, 0];
                }
                if (Pos[i, 0] > mx)
                {
                    mx = Pos[i, 0];
                }
            }
            float normx = (pictureBox1.Width - 150) / (mx - mn);
            for (i = 0; i < segments.Count; ++i)
            {
                //Segment s = new Segment(Ls[i].p1, Ls[i].p2);
                //segments.Add(s);
                //graph.DrawLine(Pens.Red, cPos[i, 0], cPos[i, 1], cPos[i, 2], pictureBox1.Height+10 - (float)segments[i].Length()*(float)norm / 2.0f);
                float lng = (float)segments[i].Length() / 2.0f;
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawLine(pen, Pos[i, 0]*normx, Pos[i, 1] - 20, Pos[i, 2]*normx, pictureBox1.Height - lng * norm - 20);
            }
            label1.Text = pix2m1(Len).ToString();
            pictureBox1.Image = image;
            //return;
            int cur_x = 10;
            graph.DrawLine(Pens.Blue, cur_x, 0, cur_x, pictureBox1.Height - 20);
            graph.DrawLine(Pens.Blue, cur_x, pictureBox1.Height - 20, pictureBox1.Width - 50, pictureBox1.Height - 20);
            float cur = 0;
            //return;
            //Thread.Sleep(2000);



            for (int q = 0; q < 10; ++q)
            {
                float lng = cur / norm;
                lng *= 2;
                float cur_y = pictureBox1.Height - (20 + cur);
           //     graph.DrawString(pix2m1(lng).ToString(), new Font("Arial", 8), new SolidBrush(Color.White), cur_x, cur_y);
                cur += (float)((pictureBox1.Height - 20 - 50) * 1.0 / 10);
            }

            float max_lng = cur / norm;
            max_lng *= 2;
            int diskr_max_lng = (int)max_lng;
            int step;
            if (diskr_max_lng < 10) step = 2;
            else if (diskr_max_lng < 100) step = 20;
            else if (diskr_max_lng < 200) step = 50;
            else if (diskr_max_lng < 400) step = 100;
            else if (diskr_max_lng < 800) step = 200;
            else if (diskr_max_lng < 1000) step = 250;
      //      else if (diskr_max_lng < 2000) diskr_max_lng = 2000;
        //    else if (diskr_max_lng < 3000) diskr_max_lng = 3000;
          //  else if (diskr_max_lng < 4000) diskr_max_lng = 4000;
         //   else if (diskr_max_lng < 5000) diskr_max_lng = 5000;
          //  else if (diskr_max_lng < 6000) diskr_max_lng = 6000;
          //  else if (diskr_max_lng < 7000) diskr_max_lng = 7000;
            else step = 12000;
       //     int step = diskr_max_lng / 4;
            cur = 0;
            float prev = pictureBox1.Height - (20);
            float cur_y1 = pictureBox1.Height - (20);
            for (int q = 0; q <= 4; ++q)
            {

                
                float tmp = cur * norm / 2.0f;
                prev = cur_y1;
                cur_y1 = pictureBox1.Height - (20 + tmp);
                if (cur_y1 > 35)
                    graph.DrawString(pix2m1(cur).ToString(), new Font("Arial", 17.5f), new SolidBrush(Color.Black), cur_x, cur_y1);
                Pen pen = new Pen(Color.Black, 2);
                graph.DrawLine(pen, cur_x - 5, cur_y1, cur_x + 5, cur_y1);
                float small_y = prev;
                float small_step = (cur_y1 - prev) / 5.0f;
          
                for (int r = 0; r < 5; ++r)
                {
                    small_y += small_step;
                    Pen pen1 = new Pen(Color.Black, 2);
                    graph.DrawLine(pen1, cur_x - 2, small_y, cur_x + 2, small_y);
                }
                cur += step;
            }

            pictureBox1.Image = image;
            //return;
            pictureBox1.Refresh();
 //           Thread.Sleep(4000);
            gist = new double[g_count + 1];
            Hg = (float)(pictureBox1.Height - 70) / (float)segments.Count;
            Hg *= (float)2.0;
            gLen = (float)600.0 / (float)g_count;
            float a = pictureBox1.Width;
            float b = pictureBox1.Height;

            Lenone = Len / (float)g_count;
            float len;
            float Add = 50;
            was = new bool[segments.Count];
            for (i = 0; i < segments.Count; ++i)
            {
                len = cPos[i, 1] - cPos[i, 3];
                len /= Lenone;
                j = (int)len;
                Pos[i, 0] = (float)j * Lenone + Add;
                Pos[i, 2] = (float)(j + 1) * Lenone + Add;
                Pos[i, 1] = Pos[i, 3] = pictureBox1.Height - 20;
            }
            button2.Enabled = true;
         //   MessageBox.Show("Нажмите продолжить для построения гистограммы.");
        }

        void Stop3()
        {
            timer1.Enabled = false;
            Form4 form4 = new Form4();
            DialogResult result = form4.ShowDialog();
            double res = form4.get_value();
            int n = (int)numericUpDown1.Value;
            double real_len = (pix2m1(pictureBox1.Height) * pix2m1(pictureBox1.Width) / (2 * Math.Sqrt(2) * pix2m1(pix_r) * n));

            Form5 form5 = new Form5((int)res, (int)pix2m1(ELen), (int)real_len);
            DialogResult result_ans = form5.ShowDialog();

         //   MessageBox.Show("Ваш ответ: " + res + "нм Правильный ответ: " + (int)pix2m1(ELen) + "нм\n" + "Теоретический ответ: " + (int)real_len + "нм");
            
            label1.Text = real_len.ToString();


        }

        void DrawRest()
        {
            int i, j;
            image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            var graph = Graphics.FromImage(image);
            segments.Sort(delegate(Segment x1, Segment y1)
            {
                Segment x, y;
                x = (Segment)x1;
                y = (Segment)y1;
                double len1 = x.Length();
                double len2 = y.Length();
                if (len1 < len2) return -1;
                if (len1 > len2) return 1;
                return 0;

            });
            float Add = 50;
            /*float cur_x = 10;
            for (int i = 0; i < segments.Count; ++i)
            {
                Segment seg = (Segment)segments[i];
                double Length = seg.Length()*0.5;
                
                graph.DrawLine(Pens.Red, cur_x, 0, cur_x, (float)Length);
                cur_x += 10;
            }
            pictureBox1.Image = image;*/
            Pos = new float[segments.Count, 4];
            cPos = new float[segments.Count, 4];
            float length = pictureBox1.Height;
            float lenone = length / (float)segments.Count;
            float curlen = 0;
            ELen = 0;
            float num = 0;
            for (i = 0; i < segments.Count; ++i, curlen += lenone)
            {
                float slen = (float)segments[i].Length();
                ELen += slen;
                if (slen > 0)
                {
                    num = num + 1;
                }
                slen *= (float)0.5;
                //graph.DrawLine(Pens.Red, Add+curlen, 0, Add+curlen, (float)slen);
                Pos[i, 0] = Add + curlen*1.6f;
                Pos[i, 1] = pictureBox1.Height;
                Pos[i, 2] = Add + curlen*1.6f;
                Pos[i, 3] = pictureBox1.Height - (float)slen;
                cPos[i, 0] = segments[i].p1.x;
                cPos[i, 1] = segments[i].p1.y;
                cPos[i, 2] = segments[i].p2.x;
                cPos[i, 3] = segments[i].p2.y;
            }
            ELen /= num;
    
            situation = 2;
            timer1.Enabled = true;
            //pictureBox1.Image = image;

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {


        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {


        }

        private void helpToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Process prc = null;
            //output = string.Empty;
            try
            {
                prc = new Process();
                prc.StartInfo.FileName = "help.pdf";
                prc.StartInfo.Arguments = "Form1.cs";

                prc.Start();

                prc.WaitForExit();
            }
            finally
            {
                if (prc != null) prc.Close();
            }
        }

        private void создателиToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Process prc = null;
            //output = string.Empty;
            try
            {
                prc = new Process();
                prc.StartInfo.FileName = "creators.doc";
                prc.StartInfo.Arguments = "Form1.cs";

                prc.Start();

                prc.WaitForExit();
            }
            finally
            {
                if (prc != null) prc.Close();
            }

        }

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {

        }

        private void textBox2_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode != Keys.Enter) return;
            try
            {
                int t = int.Parse(textBox2.Text) - 100;
                if (t >= hScrollBar2.Maximum - hScrollBar2.TabIndex - 1)
                {
                    t = hScrollBar2.Maximum - hScrollBar2.TabIndex - 1;
                    textBox2.Text = (t + 99).ToString();
                }
                if (t < hScrollBar2.Minimum)
                {
                    t = hScrollBar2.Minimum;
                    textBox2.Text = (t + 100).ToString();
                }
                hScrollBar2.Value = t;

            }
            catch
            {
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode != Keys.Enter) return;
            try
            {
                int t = (int.Parse(textBox1.Text));
                if (t >= hScrollBar1.Maximum - hScrollBar1.TabIndex - 1)
                {
                    t = hScrollBar1.Maximum - hScrollBar1.TabIndex - 1;
                    textBox3.Text = t.ToString();
                }
                if (t < hScrollBar1.Minimum)
                {
                    t = hScrollBar1.Minimum;
                    textBox1.Text = t.ToString();
                }
                hScrollBar1.Value = t;

            }
            catch
            {
            }
        }

        private void textBox3_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode != Keys.Enter) return;

            try
            {
                int t = int.Parse(textBox3.Text);
                if (t >= hScrollBar3.Maximum - hScrollBar3.TabIndex - 1)
                {
                    t = hScrollBar3.Maximum - hScrollBar3.TabIndex - 1;
                    textBox3.Text = t.ToString();
                }
                if (t < hScrollBar3.Minimum)
                {
                    t = hScrollBar3.Minimum;
                    textBox3.Text = t.ToString();
                }
                hScrollBar3.Value = t;

            }
            catch
            {
            }

        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void hScrollBar1_ValueChanged(object sender, EventArgs e)
        {
            pix_r = hScrollBar1.Value / 10;
            r = pix2m(pix_r);
            textBox1.Text = hScrollBar1.Value.ToString();

            label1.Text = hScrollBar1.Value.ToString();
        }

        private void hScrollBar2_ValueChanged(object sender, EventArgs e)
        {
            t = hScrollBar2.Value + 100;
            textBox2.Text = t.ToString();
        }

        private void hScrollBar3_ValueChanged(object sender, EventArgs e)
        {
            int tmp = hScrollBar3.Value;
            m = val2kg(tmp);
            textBox3.Text = tmp.ToString();
            label1.Text = hScrollBar3.Value.ToString();

        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (situation == 1)
            {
                DrawRest();
                button2.Enabled = false;
            }
            else if (situation == 2)
            {
                label9.Visible = false;
                
                situation = 3;
                timer1.Enabled = true;
                button2.Enabled = false;

            }
            else if (situation == 3)
            {

                button2.Enabled = false;
                Draw_prob();
                situation = 4;
            }
            else if (situation == 4)
            {
                
                button2.Enabled = false;
                Stop3();
                
            }

           
        }

    }


}

